# Tabris.js - 1.0.0

## Introduction

Tabris.js is a mobile framework that lets you develop native iOS and Android apps from a single code base written entirely in JavaScript. Tabris.js is a good choice when you are looking for native performance and look & feel while leveraging your JavaScript know-how. Tabris.js has been crafted with web APIs and extensibility on our minds. You can use existing JavaScript libraries and native extensions to extend the core functionality.

## For Beginners
- [Getting Started](getting-started.md) - Detailed instructions for the full Tabris.js experience
- [Quickstart](quickstart.md) - A compressed and stripped down version of the above.

## Documentation
- [Module System](modules.md) - How to organize and load scripts.
- [Widget Basics](widget-basics.md) - Native widget handling.
- [UI Model](ui.md) - Pages, Actions and Drawer.
- [Using Selectors](selector.md) - Working more efficiently with widgets. 
- [Layouts](layout.md) - Layouting widgets.
- [Touch Events](touch.md) - Processing widget gesture/touch events.
- [W3C Compatibility](w3c-api.md) - XMLHttpRequest, LocalStorage and timer.
- [Cordova Support](cordova.md) - Using Cordova plug-ins, including Dialogs, File and Camera
- [Build your app](build.md) - Create a standalone app from your Tabris.js project files


## API Reference

<%= api %>
- [Data Types](types.md)

### Widgets
<%= widgets %>

## Articles
- [Apache Cordova vs. Tabris.js](http://eclipsesource.com/blogs/2015/03/02/apache-cordova-vs-tabris-js/) - How to use Cordova's build tooling to create Tabris.js apps.
- [Layouting in Tabris.js](http://eclipsesource.com/blogs/2015/02/19/layouting-in-tabris-js/) - Layouting explained.
- [CollectionView: Display Data Sets in Tabris.js](http://eclipsesource.com/blogs/2015/02/16/collectionview-display-data-sets-in-tabris-js/) - The power of the CollectionView in detail.

### Tabris.js Examples
This blog post series takes a closer look at the examples.

- [Hello World!](http://eclipsesource.com/blogs/2015/02/20/tabris-js-examples-hello-world/)
- [User Input](http://eclipsesource.com/blogs/2015/02/25/tabris-js-examples-user-input/)
- [Local Storage](http://eclipsesource.com/blogs/2015/03/04/tabris-js-examples-local-storage/)
- [Images](http://eclipsesource.com/blogs/2015/03/10/tabris-js-examples-images/)
- [Parallax Scrolling](http://eclipsesource.com/blogs/2015/03/24/tabris-js-examples-parallax-scrolling/)
- [Animations](http://eclipsesource.com/blogs/2015/04/14/tabris-js-examples-animations/)
- [Drawing on the Canvas](http://eclipsesource.com/blogs/2015/04/15/tabris-js-examples-drawing-on-the-canvas/)
- [Network Access](http://eclipsesource.com/blogs/2015/04/24/tabris-js-examples-network-access/)
